package com.ms.xml.util;

import java.io.IOException;
import java.util.Hashtable;

public class QualifiedName extends Name {
   public static int created;
   public static int reused;
   static final String separator = "::";
   static Hashtable qnames = new Hashtable(500);
   Name nameSpace;
   Name name;

   public static Name getNameSpace(Name var0) {
      return var0 instanceof QualifiedName ? ((QualifiedName)var0).getNameSpace() : null;
   }

   public String toString() {
      return this.nameSpace != null ? new String(this.nameSpace.toString() + "::" + this.name.toString()) : this.name.toString();
   }

   public static QualifiedName create(Name var0, Name var1) {
      if (var0 == null) {
         return null;
      } else {
         int var2 = var1 == null ? var0.hashCode() : var0.hashCode() + var1.hashCode();
         QualifiedName var3 = new QualifiedName(var0, var1, var2);
         Object var4 = qnames.get(var3);
         if (var4 == null) {
            ++created;
            qnames.put(var3, var3);
            return var3;
         } else {
            ++reused;
            return (QualifiedName)var4;
         }
      }
   }

   QualifiedName(Name var1, Name var2, int var3) {
      super(var1.toString(), var3);
      this.name = var1;
      this.nameSpace = var2;
   }

   public boolean equals(Object var1) {
      if (this == var1) {
         return true;
      } else if (var1 != null && this.getClass() == var1.getClass()) {
         QualifiedName var2 = (QualifiedName)var1;
         if (this.nameSpace != null) {
            if (!this.nameSpace.equals(var2.nameSpace)) {
               return false;
            }
         } else if (var2.nameSpace != null) {
            return false;
         }

         return this.name.equals(var2.name);
      } else {
         return false;
      }
   }

   public void save(XMLOutputStream var1) {
      if (this.name != null) {
         try {
            if (this.nameSpace == null) {
               var1.writeChars(this.name.toString());
            } else {
               var1.writeChars(var1.dtd.findShortNameSpace(this.nameSpace).toString() + "::" + this.name.toString());
            }
         } catch (IOException var4) {
            System.out.println(var4);
         }
      }
   }

   public Name getName() {
      return this.name;
   }

   public Name getNameSpace() {
      return this.nameSpace;
   }
}
